/* SystemGroup.c generated by valac 0.48.1, the Vala compiler
 * generated from SystemGroup.vala, do not modify */

/*
 * SystemGroup.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#define TYPE_SYSTEM_GROUP (system_group_get_type ())
#define SYSTEM_GROUP(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_GROUP, SystemGroup))
#define SYSTEM_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYSTEM_GROUP, SystemGroupClass))
#define IS_SYSTEM_GROUP(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_GROUP))
#define IS_SYSTEM_GROUP_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYSTEM_GROUP))
#define SYSTEM_GROUP_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYSTEM_GROUP, SystemGroupClass))

typedef struct _SystemGroup SystemGroup;
typedef struct _SystemGroupClass SystemGroupClass;
typedef struct _SystemGroupPrivate SystemGroupPrivate;
enum  {
	SYSTEM_GROUP_0_PROPERTY,
	SYSTEM_GROUP_IS_INSTALLED_PROPERTY,
	SYSTEM_GROUP_IS_SYSTEM_PROPERTY,
	SYSTEM_GROUP_NUM_PROPERTIES
};
static GParamSpec* system_group_properties[SYSTEM_GROUP_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SystemGroup {
	GObject parent_instance;
	SystemGroupPrivate * priv;
	gchar* name;
	gchar* password;
	gint gid;
	gchar* user_names;
	gchar* shadow_line;
	gchar* password_hash;
	gchar* admin_list;
	gchar* member_list;
	gboolean is_selected;
	GeeArrayList* users;
};

struct _SystemGroupClass {
	GObjectClass parent_class;
};

static gpointer system_group_parent_class = NULL;
extern GeeHashMap* system_group_all_groups;
GeeHashMap* system_group_all_groups = NULL;

GType system_group_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SystemGroup, g_object_unref)
SystemGroup* system_group_new (const gchar* name);
SystemGroup* system_group_construct (GType object_type,
                                     const gchar* name);
void system_group_query_groups (gboolean no_passwords);
GeeHashMap* system_group_read_groups_from_file (const gchar* group_file,
                                                const gchar* gshadow_file,
                                                const gchar* password);
gchar* tee_jee_file_system_file_decrypt_untar_read (const gchar* src_file,
                                                    const gchar* password);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static SystemGroup* system_group_parse_line_group (const gchar* line);
static SystemGroup* system_group_parse_line_gshadow (const gchar* line,
                                              GeeHashMap* list);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gint system_group_add_group (const gchar* group_name,
                             gboolean system_account);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gint system_group_add (SystemGroup* self);
gboolean system_group_get_is_system (SystemGroup* self);
gint system_group_add_user_to_group (const gchar* user_name,
                                     const gchar* group_name);
void tee_jee_logging_log_debug (const gchar* message);
gint system_group_add_to_group (SystemGroup* self,
                                const gchar* user_name);
gboolean system_group_update_group_file (SystemGroup* self);
gchar* system_group_get_group_line (SystemGroup* self);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean system_group_update_gshadow_file (SystemGroup* self);
gchar* system_group_get_gshadow_line (SystemGroup* self);
GeeArrayList* system_group_get_all_groups_sorted (void);
static gint _system_group_all_groups_sorted___lambda17_ (SystemGroup* a,
                                                  SystemGroup* b);
static gint __system_group_all_groups_sorted___lambda17__gcompare_data_func (gconstpointer a,
                                                                      gconstpointer b,
                                                                      gpointer self);
gboolean system_group_get_is_installed (SystemGroup* self);
static void system_group_finalize (GObject * obj);
static GType system_group_get_type_once (void);
static void _vala_system_group_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

SystemGroup*
system_group_construct (GType object_type,
                        const gchar* name)
{
	SystemGroup * self = NULL;
	gchar* _tmp0_;
	GeeArrayList* _tmp1_;
#line 46 "Utility/SystemGroup.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 46 "Utility/SystemGroup.vala"
	self = (SystemGroup*) g_object_new (object_type, NULL);
#line 47 "Utility/SystemGroup.vala"
	_tmp0_ = g_strdup (name);
#line 47 "Utility/SystemGroup.vala"
	_g_free0 (self->name);
#line 47 "Utility/SystemGroup.vala"
	self->name = _tmp0_;
#line 48 "Utility/SystemGroup.vala"
	_tmp1_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 48 "Utility/SystemGroup.vala"
	_g_object_unref0 (self->users);
#line 48 "Utility/SystemGroup.vala"
	self->users = _tmp1_;
#line 46 "Utility/SystemGroup.vala"
	return self;
#line 161 "SystemGroup.c"
}

SystemGroup*
system_group_new (const gchar* name)
{
#line 46 "Utility/SystemGroup.vala"
	return system_group_construct (TYPE_SYSTEM_GROUP, name);
#line 169 "SystemGroup.c"
}

void
system_group_query_groups (gboolean no_passwords)
{
#line 52 "Utility/SystemGroup.vala"
	if (no_passwords) {
#line 177 "SystemGroup.c"
		GeeHashMap* _tmp0_;
#line 53 "Utility/SystemGroup.vala"
		_tmp0_ = system_group_read_groups_from_file ("/etc/group", "", "");
#line 53 "Utility/SystemGroup.vala"
		_g_object_unref0 (system_group_all_groups);
#line 53 "Utility/SystemGroup.vala"
		system_group_all_groups = _tmp0_;
#line 185 "SystemGroup.c"
	} else {
		GeeHashMap* _tmp1_;
#line 56 "Utility/SystemGroup.vala"
		_tmp1_ = system_group_read_groups_from_file ("/etc/group", "/etc/gshadow", "");
#line 56 "Utility/SystemGroup.vala"
		_g_object_unref0 (system_group_all_groups);
#line 56 "Utility/SystemGroup.vala"
		system_group_all_groups = _tmp1_;
#line 194 "SystemGroup.c"
	}
}

GeeHashMap*
system_group_read_groups_from_file (const gchar* group_file,
                                    const gchar* gshadow_file,
                                    const gchar* password)
{
	GeeHashMap* list = NULL;
	GeeHashMap* _tmp0_;
	gchar* txt = NULL;
	gchar* _tmp1_;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	const gchar* _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp23_;
	gint _tmp24_;
	gchar* _tmp25_;
	const gchar* _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	const gchar* _tmp31_;
	gchar** _tmp32_;
	gchar** _tmp33_;
	GeeHashMap* result = NULL;
#line 77 "Utility/SystemGroup.vala"
	g_return_val_if_fail (group_file != NULL, NULL);
#line 77 "Utility/SystemGroup.vala"
	g_return_val_if_fail (gshadow_file != NULL, NULL);
#line 77 "Utility/SystemGroup.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 78 "Utility/SystemGroup.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_SYSTEM_GROUP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 78 "Utility/SystemGroup.vala"
	list = _tmp0_;
#line 82 "Utility/SystemGroup.vala"
	_tmp1_ = g_strdup ("");
#line 82 "Utility/SystemGroup.vala"
	txt = _tmp1_;
#line 84 "Utility/SystemGroup.vala"
	if (g_str_has_suffix (group_file, ".tar.gpg")) {
#line 239 "SystemGroup.c"
		gchar* _tmp2_;
#line 85 "Utility/SystemGroup.vala"
		_tmp2_ = tee_jee_file_system_file_decrypt_untar_read (group_file, password);
#line 85 "Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 85 "Utility/SystemGroup.vala"
		txt = _tmp2_;
#line 247 "SystemGroup.c"
	} else {
		gchar* _tmp3_;
#line 88 "Utility/SystemGroup.vala"
		_tmp3_ = tee_jee_file_system_file_read (group_file);
#line 88 "Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 88 "Utility/SystemGroup.vala"
		txt = _tmp3_;
#line 256 "SystemGroup.c"
	}
#line 91 "Utility/SystemGroup.vala"
	_tmp4_ = txt;
#line 91 "Utility/SystemGroup.vala"
	_tmp5_ = strlen (_tmp4_);
#line 91 "Utility/SystemGroup.vala"
	_tmp6_ = _tmp5_;
#line 91 "Utility/SystemGroup.vala"
	if (_tmp6_ == 0) {
#line 92 "Utility/SystemGroup.vala"
		result = list;
#line 92 "Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 92 "Utility/SystemGroup.vala"
		return result;
#line 272 "SystemGroup.c"
	}
#line 95 "Utility/SystemGroup.vala"
	_tmp7_ = txt;
#line 95 "Utility/SystemGroup.vala"
	_tmp9_ = _tmp8_ = g_strsplit (_tmp7_, "\n", 0);
#line 278 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 95 "Utility/SystemGroup.vala"
		line_collection = _tmp9_;
#line 95 "Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp8_);
#line 95 "Utility/SystemGroup.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 290 "SystemGroup.c"
			gchar* _tmp10_;
			gchar* line = NULL;
#line 95 "Utility/SystemGroup.vala"
			_tmp10_ = g_strdup (line_collection[line_it]);
#line 95 "Utility/SystemGroup.vala"
			line = _tmp10_;
#line 297 "SystemGroup.c"
			{
				gboolean _tmp11_ = FALSE;
				const gchar* _tmp12_;
				SystemGroup* group = NULL;
				const gchar* _tmp16_;
				SystemGroup* _tmp17_;
				SystemGroup* _tmp18_;
#line 96 "Utility/SystemGroup.vala"
				_tmp12_ = line;
#line 96 "Utility/SystemGroup.vala"
				if (_tmp12_ == NULL) {
#line 96 "Utility/SystemGroup.vala"
					_tmp11_ = TRUE;
#line 311 "SystemGroup.c"
				} else {
					const gchar* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
#line 96 "Utility/SystemGroup.vala"
					_tmp13_ = line;
#line 96 "Utility/SystemGroup.vala"
					_tmp14_ = strlen (_tmp13_);
#line 96 "Utility/SystemGroup.vala"
					_tmp15_ = _tmp14_;
#line 96 "Utility/SystemGroup.vala"
					_tmp11_ = _tmp15_ == 0;
#line 324 "SystemGroup.c"
				}
#line 96 "Utility/SystemGroup.vala"
				if (_tmp11_) {
#line 97 "Utility/SystemGroup.vala"
					_g_free0 (line);
#line 97 "Utility/SystemGroup.vala"
					continue;
#line 332 "SystemGroup.c"
				}
#line 100 "Utility/SystemGroup.vala"
				_tmp16_ = line;
#line 100 "Utility/SystemGroup.vala"
				_tmp17_ = system_group_parse_line_group (_tmp16_);
#line 100 "Utility/SystemGroup.vala"
				group = _tmp17_;
#line 101 "Utility/SystemGroup.vala"
				_tmp18_ = group;
#line 101 "Utility/SystemGroup.vala"
				if (_tmp18_ != NULL) {
#line 344 "SystemGroup.c"
					GeeHashMap* _tmp19_;
					SystemGroup* _tmp20_;
					const gchar* _tmp21_;
					SystemGroup* _tmp22_;
#line 102 "Utility/SystemGroup.vala"
					_tmp19_ = list;
#line 102 "Utility/SystemGroup.vala"
					_tmp20_ = group;
#line 102 "Utility/SystemGroup.vala"
					_tmp21_ = _tmp20_->name;
#line 102 "Utility/SystemGroup.vala"
					_tmp22_ = group;
#line 102 "Utility/SystemGroup.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, _tmp21_, _tmp22_);
#line 359 "SystemGroup.c"
				}
#line 95 "Utility/SystemGroup.vala"
				_g_object_unref0 (group);
#line 95 "Utility/SystemGroup.vala"
				_g_free0 (line);
#line 365 "SystemGroup.c"
			}
		}
#line 95 "Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 370 "SystemGroup.c"
	}
#line 106 "Utility/SystemGroup.vala"
	_tmp23_ = strlen (gshadow_file);
#line 106 "Utility/SystemGroup.vala"
	_tmp24_ = _tmp23_;
#line 106 "Utility/SystemGroup.vala"
	if (_tmp24_ == 0) {
#line 107 "Utility/SystemGroup.vala"
		result = list;
#line 107 "Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 107 "Utility/SystemGroup.vala"
		return result;
#line 384 "SystemGroup.c"
	}
#line 112 "Utility/SystemGroup.vala"
	_tmp25_ = g_strdup ("");
#line 112 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 112 "Utility/SystemGroup.vala"
	txt = _tmp25_;
#line 114 "Utility/SystemGroup.vala"
	if (g_str_has_suffix (gshadow_file, ".tar.gpg")) {
#line 394 "SystemGroup.c"
		gchar* _tmp26_;
#line 115 "Utility/SystemGroup.vala"
		_tmp26_ = tee_jee_file_system_file_decrypt_untar_read (gshadow_file, password);
#line 115 "Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 115 "Utility/SystemGroup.vala"
		txt = _tmp26_;
#line 402 "SystemGroup.c"
	} else {
		gchar* _tmp27_;
#line 118 "Utility/SystemGroup.vala"
		_tmp27_ = tee_jee_file_system_file_read (gshadow_file);
#line 118 "Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 118 "Utility/SystemGroup.vala"
		txt = _tmp27_;
#line 411 "SystemGroup.c"
	}
#line 121 "Utility/SystemGroup.vala"
	_tmp28_ = txt;
#line 121 "Utility/SystemGroup.vala"
	_tmp29_ = strlen (_tmp28_);
#line 121 "Utility/SystemGroup.vala"
	_tmp30_ = _tmp29_;
#line 121 "Utility/SystemGroup.vala"
	if (_tmp30_ == 0) {
#line 122 "Utility/SystemGroup.vala"
		result = list;
#line 122 "Utility/SystemGroup.vala"
		_g_free0 (txt);
#line 122 "Utility/SystemGroup.vala"
		return result;
#line 427 "SystemGroup.c"
	}
#line 125 "Utility/SystemGroup.vala"
	_tmp31_ = txt;
#line 125 "Utility/SystemGroup.vala"
	_tmp33_ = _tmp32_ = g_strsplit (_tmp31_, "\n", 0);
#line 433 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 125 "Utility/SystemGroup.vala"
		line_collection = _tmp33_;
#line 125 "Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp32_);
#line 125 "Utility/SystemGroup.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 445 "SystemGroup.c"
			gchar* _tmp34_;
			gchar* line = NULL;
#line 125 "Utility/SystemGroup.vala"
			_tmp34_ = g_strdup (line_collection[line_it]);
#line 125 "Utility/SystemGroup.vala"
			line = _tmp34_;
#line 452 "SystemGroup.c"
			{
				gboolean _tmp35_ = FALSE;
				const gchar* _tmp36_;
				const gchar* _tmp40_;
				GeeHashMap* _tmp41_;
				SystemGroup* _tmp42_;
				SystemGroup* _tmp43_;
#line 126 "Utility/SystemGroup.vala"
				_tmp36_ = line;
#line 126 "Utility/SystemGroup.vala"
				if (_tmp36_ == NULL) {
#line 126 "Utility/SystemGroup.vala"
					_tmp35_ = TRUE;
#line 466 "SystemGroup.c"
				} else {
					const gchar* _tmp37_;
					gint _tmp38_;
					gint _tmp39_;
#line 126 "Utility/SystemGroup.vala"
					_tmp37_ = line;
#line 126 "Utility/SystemGroup.vala"
					_tmp38_ = strlen (_tmp37_);
#line 126 "Utility/SystemGroup.vala"
					_tmp39_ = _tmp38_;
#line 126 "Utility/SystemGroup.vala"
					_tmp35_ = _tmp39_ == 0;
#line 479 "SystemGroup.c"
				}
#line 126 "Utility/SystemGroup.vala"
				if (_tmp35_) {
#line 127 "Utility/SystemGroup.vala"
					_g_free0 (line);
#line 127 "Utility/SystemGroup.vala"
					continue;
#line 487 "SystemGroup.c"
				}
#line 130 "Utility/SystemGroup.vala"
				_tmp40_ = line;
#line 130 "Utility/SystemGroup.vala"
				_tmp41_ = list;
#line 130 "Utility/SystemGroup.vala"
				_tmp42_ = system_group_parse_line_gshadow (_tmp40_, _tmp41_);
#line 130 "Utility/SystemGroup.vala"
				_tmp43_ = _tmp42_;
#line 130 "Utility/SystemGroup.vala"
				_g_object_unref0 (_tmp43_);
#line 125 "Utility/SystemGroup.vala"
				_g_free0 (line);
#line 501 "SystemGroup.c"
			}
		}
#line 125 "Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 506 "SystemGroup.c"
	}
#line 133 "Utility/SystemGroup.vala"
	result = list;
#line 133 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 133 "Utility/SystemGroup.vala"
	return result;
#line 514 "SystemGroup.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 535 "SystemGroup.c"
}

static SystemGroup*
system_group_parse_line_group (const gchar* line)
{
	gboolean _tmp0_ = FALSE;
	SystemGroup* group = NULL;
	gchar** fields = NULL;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	SystemGroup* result = NULL;
#line 136 "Utility/SystemGroup.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 137 "Utility/SystemGroup.vala"
	if (line == NULL) {
#line 137 "Utility/SystemGroup.vala"
		_tmp0_ = TRUE;
#line 557 "SystemGroup.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 137 "Utility/SystemGroup.vala"
		_tmp1_ = strlen (line);
#line 137 "Utility/SystemGroup.vala"
		_tmp2_ = _tmp1_;
#line 137 "Utility/SystemGroup.vala"
		_tmp0_ = _tmp2_ == 0;
#line 567 "SystemGroup.c"
	}
#line 137 "Utility/SystemGroup.vala"
	if (_tmp0_) {
#line 138 "Utility/SystemGroup.vala"
		result = NULL;
#line 138 "Utility/SystemGroup.vala"
		return result;
#line 575 "SystemGroup.c"
	}
#line 141 "Utility/SystemGroup.vala"
	group = NULL;
#line 144 "Utility/SystemGroup.vala"
	_tmp4_ = _tmp3_ = g_strsplit (line, ":", 0);
#line 144 "Utility/SystemGroup.vala"
	fields = _tmp4_;
#line 144 "Utility/SystemGroup.vala"
	fields_length1 = _vala_array_length (_tmp3_);
#line 144 "Utility/SystemGroup.vala"
	_fields_size_ = fields_length1;
#line 146 "Utility/SystemGroup.vala"
	_tmp5_ = fields;
#line 146 "Utility/SystemGroup.vala"
	_tmp5__length1 = fields_length1;
#line 146 "Utility/SystemGroup.vala"
	if (_tmp5__length1 == 4) {
#line 593 "SystemGroup.c"
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		SystemGroup* _tmp10_;
		SystemGroup* _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		SystemGroup* _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		SystemGroup* _tmp20_;
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		SystemGroup* _tmp24_;
		const gchar* _tmp25_;
		gchar** _tmp26_;
		gchar** _tmp27_;
#line 147 "Utility/SystemGroup.vala"
		_tmp6_ = fields;
#line 147 "Utility/SystemGroup.vala"
		_tmp6__length1 = fields_length1;
#line 147 "Utility/SystemGroup.vala"
		_tmp7_ = _tmp6_[0];
#line 147 "Utility/SystemGroup.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 147 "Utility/SystemGroup.vala"
		_tmp9_ = _tmp8_;
#line 147 "Utility/SystemGroup.vala"
		_tmp10_ = system_group_new (_tmp9_);
#line 147 "Utility/SystemGroup.vala"
		_g_object_unref0 (group);
#line 147 "Utility/SystemGroup.vala"
		group = _tmp10_;
#line 147 "Utility/SystemGroup.vala"
		_g_free0 (_tmp9_);
#line 148 "Utility/SystemGroup.vala"
		_tmp11_ = group;
#line 148 "Utility/SystemGroup.vala"
		_tmp12_ = fields;
#line 148 "Utility/SystemGroup.vala"
		_tmp12__length1 = fields_length1;
#line 148 "Utility/SystemGroup.vala"
		_tmp13_ = _tmp12_[1];
#line 148 "Utility/SystemGroup.vala"
		_tmp14_ = string_strip (_tmp13_);
#line 148 "Utility/SystemGroup.vala"
		_g_free0 (_tmp11_->password);
#line 148 "Utility/SystemGroup.vala"
		_tmp11_->password = _tmp14_;
#line 149 "Utility/SystemGroup.vala"
		_tmp15_ = group;
#line 149 "Utility/SystemGroup.vala"
		_tmp16_ = fields;
#line 149 "Utility/SystemGroup.vala"
		_tmp16__length1 = fields_length1;
#line 149 "Utility/SystemGroup.vala"
		_tmp17_ = _tmp16_[2];
#line 149 "Utility/SystemGroup.vala"
		_tmp18_ = string_strip (_tmp17_);
#line 149 "Utility/SystemGroup.vala"
		_tmp19_ = _tmp18_;
#line 149 "Utility/SystemGroup.vala"
		_tmp15_->gid = atoi (_tmp19_);
#line 149 "Utility/SystemGroup.vala"
		_g_free0 (_tmp19_);
#line 150 "Utility/SystemGroup.vala"
		_tmp20_ = group;
#line 150 "Utility/SystemGroup.vala"
		_tmp21_ = fields;
#line 150 "Utility/SystemGroup.vala"
		_tmp21__length1 = fields_length1;
#line 150 "Utility/SystemGroup.vala"
		_tmp22_ = _tmp21_[3];
#line 150 "Utility/SystemGroup.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 150 "Utility/SystemGroup.vala"
		_g_free0 (_tmp20_->user_names);
#line 150 "Utility/SystemGroup.vala"
		_tmp20_->user_names = _tmp23_;
#line 151 "Utility/SystemGroup.vala"
		_tmp24_ = group;
#line 151 "Utility/SystemGroup.vala"
		_tmp25_ = _tmp24_->user_names;
#line 151 "Utility/SystemGroup.vala"
		_tmp27_ = _tmp26_ = g_strsplit (_tmp25_, ",", 0);
#line 688 "SystemGroup.c"
		{
			gchar** user_name_collection = NULL;
			gint user_name_collection_length1 = 0;
			gint _user_name_collection_size_ = 0;
			gint user_name_it = 0;
#line 151 "Utility/SystemGroup.vala"
			user_name_collection = _tmp27_;
#line 151 "Utility/SystemGroup.vala"
			user_name_collection_length1 = _vala_array_length (_tmp26_);
#line 151 "Utility/SystemGroup.vala"
			for (user_name_it = 0; user_name_it < user_name_collection_length1; user_name_it = user_name_it + 1) {
#line 700 "SystemGroup.c"
				gchar* _tmp28_;
				gchar* user_name = NULL;
#line 151 "Utility/SystemGroup.vala"
				_tmp28_ = g_strdup (user_name_collection[user_name_it]);
#line 151 "Utility/SystemGroup.vala"
				user_name = _tmp28_;
#line 707 "SystemGroup.c"
				{
					SystemGroup* _tmp29_;
					GeeArrayList* _tmp30_;
					const gchar* _tmp31_;
#line 152 "Utility/SystemGroup.vala"
					_tmp29_ = group;
#line 152 "Utility/SystemGroup.vala"
					_tmp30_ = _tmp29_->users;
#line 152 "Utility/SystemGroup.vala"
					_tmp31_ = user_name;
#line 152 "Utility/SystemGroup.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp30_, _tmp31_);
#line 151 "Utility/SystemGroup.vala"
					_g_free0 (user_name);
#line 722 "SystemGroup.c"
				}
			}
#line 151 "Utility/SystemGroup.vala"
			user_name_collection = (_vala_array_free (user_name_collection, user_name_collection_length1, (GDestroyNotify) g_free), NULL);
#line 727 "SystemGroup.c"
		}
	} else {
		gchar** _tmp32_;
		gint _tmp32__length1;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
#line 156 "Utility/SystemGroup.vala"
		_tmp32_ = fields;
#line 156 "Utility/SystemGroup.vala"
		_tmp32__length1 = fields_length1;
#line 156 "Utility/SystemGroup.vala"
		_tmp33_ = g_strdup_printf (": %d", _tmp32__length1);
#line 156 "Utility/SystemGroup.vala"
		_tmp34_ = _tmp33_;
#line 156 "Utility/SystemGroup.vala"
		_tmp35_ = g_strconcat ("'group' file contains a record with non-standard fields", _tmp34_, NULL);
#line 156 "Utility/SystemGroup.vala"
		_tmp36_ = _tmp35_;
#line 156 "Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp36_, FALSE, FALSE);
#line 156 "Utility/SystemGroup.vala"
		_g_free0 (_tmp36_);
#line 156 "Utility/SystemGroup.vala"
		_g_free0 (_tmp34_);
#line 157 "Utility/SystemGroup.vala"
		result = NULL;
#line 157 "Utility/SystemGroup.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 157 "Utility/SystemGroup.vala"
		_g_object_unref0 (group);
#line 157 "Utility/SystemGroup.vala"
		return result;
#line 762 "SystemGroup.c"
	}
#line 160 "Utility/SystemGroup.vala"
	result = group;
#line 160 "Utility/SystemGroup.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 160 "Utility/SystemGroup.vala"
	return result;
#line 770 "SystemGroup.c"
}

static SystemGroup*
system_group_parse_line_gshadow (const gchar* line,
                                 GeeHashMap* list)
{
	gboolean _tmp0_ = FALSE;
	SystemGroup* group = NULL;
	gchar** fields = NULL;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	SystemGroup* result = NULL;
#line 163 "Utility/SystemGroup.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 163 "Utility/SystemGroup.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 164 "Utility/SystemGroup.vala"
	if (line == NULL) {
#line 164 "Utility/SystemGroup.vala"
		_tmp0_ = TRUE;
#line 795 "SystemGroup.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 164 "Utility/SystemGroup.vala"
		_tmp1_ = strlen (line);
#line 164 "Utility/SystemGroup.vala"
		_tmp2_ = _tmp1_;
#line 164 "Utility/SystemGroup.vala"
		_tmp0_ = _tmp2_ == 0;
#line 805 "SystemGroup.c"
	}
#line 164 "Utility/SystemGroup.vala"
	if (_tmp0_) {
#line 165 "Utility/SystemGroup.vala"
		result = NULL;
#line 165 "Utility/SystemGroup.vala"
		return result;
#line 813 "SystemGroup.c"
	}
#line 168 "Utility/SystemGroup.vala"
	group = NULL;
#line 172 "Utility/SystemGroup.vala"
	_tmp4_ = _tmp3_ = g_strsplit (line, ":", 0);
#line 172 "Utility/SystemGroup.vala"
	fields = _tmp4_;
#line 172 "Utility/SystemGroup.vala"
	fields_length1 = _vala_array_length (_tmp3_);
#line 172 "Utility/SystemGroup.vala"
	_fields_size_ = fields_length1;
#line 174 "Utility/SystemGroup.vala"
	_tmp5_ = fields;
#line 174 "Utility/SystemGroup.vala"
	_tmp5__length1 = fields_length1;
#line 174 "Utility/SystemGroup.vala"
	if (_tmp5__length1 == 4) {
#line 831 "SystemGroup.c"
		gchar* group_name = NULL;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
#line 175 "Utility/SystemGroup.vala"
		_tmp6_ = fields;
#line 175 "Utility/SystemGroup.vala"
		_tmp6__length1 = fields_length1;
#line 175 "Utility/SystemGroup.vala"
		_tmp7_ = _tmp6_[0];
#line 175 "Utility/SystemGroup.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 175 "Utility/SystemGroup.vala"
		group_name = _tmp8_;
#line 176 "Utility/SystemGroup.vala"
		_tmp9_ = group_name;
#line 176 "Utility/SystemGroup.vala"
		if (gee_abstract_map_has_key ((GeeAbstractMap*) list, _tmp9_)) {
#line 852 "SystemGroup.c"
			const gchar* _tmp10_;
			gpointer _tmp11_;
			SystemGroup* _tmp12_;
			gchar* _tmp13_;
			SystemGroup* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			SystemGroup* _tmp18_;
			gchar** _tmp19_;
			gint _tmp19__length1;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			SystemGroup* _tmp22_;
			gchar** _tmp23_;
			gint _tmp23__length1;
			const gchar* _tmp24_;
			gchar* _tmp25_;
#line 177 "Utility/SystemGroup.vala"
			_tmp10_ = group_name;
#line 177 "Utility/SystemGroup.vala"
			_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) list, _tmp10_);
#line 177 "Utility/SystemGroup.vala"
			_g_object_unref0 (group);
#line 177 "Utility/SystemGroup.vala"
			group = (SystemGroup*) _tmp11_;
#line 178 "Utility/SystemGroup.vala"
			_tmp12_ = group;
#line 178 "Utility/SystemGroup.vala"
			_tmp13_ = g_strdup (line);
#line 178 "Utility/SystemGroup.vala"
			_g_free0 (_tmp12_->shadow_line);
#line 178 "Utility/SystemGroup.vala"
			_tmp12_->shadow_line = _tmp13_;
#line 179 "Utility/SystemGroup.vala"
			_tmp14_ = group;
#line 179 "Utility/SystemGroup.vala"
			_tmp15_ = fields;
#line 179 "Utility/SystemGroup.vala"
			_tmp15__length1 = fields_length1;
#line 179 "Utility/SystemGroup.vala"
			_tmp16_ = _tmp15_[1];
#line 179 "Utility/SystemGroup.vala"
			_tmp17_ = string_strip (_tmp16_);
#line 179 "Utility/SystemGroup.vala"
			_g_free0 (_tmp14_->password_hash);
#line 179 "Utility/SystemGroup.vala"
			_tmp14_->password_hash = _tmp17_;
#line 180 "Utility/SystemGroup.vala"
			_tmp18_ = group;
#line 180 "Utility/SystemGroup.vala"
			_tmp19_ = fields;
#line 180 "Utility/SystemGroup.vala"
			_tmp19__length1 = fields_length1;
#line 180 "Utility/SystemGroup.vala"
			_tmp20_ = _tmp19_[2];
#line 180 "Utility/SystemGroup.vala"
			_tmp21_ = string_strip (_tmp20_);
#line 180 "Utility/SystemGroup.vala"
			_g_free0 (_tmp18_->admin_list);
#line 180 "Utility/SystemGroup.vala"
			_tmp18_->admin_list = _tmp21_;
#line 181 "Utility/SystemGroup.vala"
			_tmp22_ = group;
#line 181 "Utility/SystemGroup.vala"
			_tmp23_ = fields;
#line 181 "Utility/SystemGroup.vala"
			_tmp23__length1 = fields_length1;
#line 181 "Utility/SystemGroup.vala"
			_tmp24_ = _tmp23_[3];
#line 181 "Utility/SystemGroup.vala"
			_tmp25_ = string_strip (_tmp24_);
#line 181 "Utility/SystemGroup.vala"
			_g_free0 (_tmp22_->member_list);
#line 181 "Utility/SystemGroup.vala"
			_tmp22_->member_list = _tmp25_;
#line 182 "Utility/SystemGroup.vala"
			result = group;
#line 182 "Utility/SystemGroup.vala"
			_g_free0 (group_name);
#line 182 "Utility/SystemGroup.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 182 "Utility/SystemGroup.vala"
			return result;
#line 938 "SystemGroup.c"
		} else {
			const gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 185 "Utility/SystemGroup.vala"
			_tmp26_ = group_name;
#line 185 "Utility/SystemGroup.vala"
			_tmp27_ = g_strdup_printf (": %s", _tmp26_);
#line 185 "Utility/SystemGroup.vala"
			_tmp28_ = _tmp27_;
#line 185 "Utility/SystemGroup.vala"
			_tmp29_ = g_strconcat ("group in file 'gshadow' does not exist in file 'group'", _tmp28_, NULL);
#line 185 "Utility/SystemGroup.vala"
			_tmp30_ = _tmp29_;
#line 185 "Utility/SystemGroup.vala"
			tee_jee_logging_log_error (_tmp30_, FALSE, FALSE);
#line 185 "Utility/SystemGroup.vala"
			_g_free0 (_tmp30_);
#line 185 "Utility/SystemGroup.vala"
			_g_free0 (_tmp28_);
#line 186 "Utility/SystemGroup.vala"
			result = NULL;
#line 186 "Utility/SystemGroup.vala"
			_g_free0 (group_name);
#line 186 "Utility/SystemGroup.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 186 "Utility/SystemGroup.vala"
			_g_object_unref0 (group);
#line 186 "Utility/SystemGroup.vala"
			return result;
#line 971 "SystemGroup.c"
		}
#line 174 "Utility/SystemGroup.vala"
		_g_free0 (group_name);
#line 975 "SystemGroup.c"
	} else {
		gchar** _tmp31_;
		gint _tmp31__length1;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
#line 190 "Utility/SystemGroup.vala"
		_tmp31_ = fields;
#line 190 "Utility/SystemGroup.vala"
		_tmp31__length1 = fields_length1;
#line 190 "Utility/SystemGroup.vala"
		_tmp32_ = g_strdup_printf (": %d", _tmp31__length1);
#line 190 "Utility/SystemGroup.vala"
		_tmp33_ = _tmp32_;
#line 190 "Utility/SystemGroup.vala"
		_tmp34_ = g_strconcat ("'gshadow' file contains a record with non-standard fields", _tmp33_, NULL);
#line 190 "Utility/SystemGroup.vala"
		_tmp35_ = _tmp34_;
#line 190 "Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp35_, FALSE, FALSE);
#line 190 "Utility/SystemGroup.vala"
		_g_free0 (_tmp35_);
#line 190 "Utility/SystemGroup.vala"
		_g_free0 (_tmp33_);
#line 191 "Utility/SystemGroup.vala"
		result = NULL;
#line 191 "Utility/SystemGroup.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 191 "Utility/SystemGroup.vala"
		_g_object_unref0 (group);
#line 191 "Utility/SystemGroup.vala"
		return result;
#line 1009 "SystemGroup.c"
	}
#line 163 "Utility/SystemGroup.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 163 "Utility/SystemGroup.vala"
	_g_object_unref0 (group);
#line 1015 "SystemGroup.c"
}

gint
system_group_add_group (const gchar* group_name,
                        gboolean system_account)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gint status = 0;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_;
	gint result = 0;
#line 195 "Utility/SystemGroup.vala"
	g_return_val_if_fail (group_name != NULL, 0);
#line 197 "Utility/SystemGroup.vala"
	if (system_account) {
#line 197 "Utility/SystemGroup.vala"
		_tmp0_ = " --system";
#line 1039 "SystemGroup.c"
	} else {
#line 197 "Utility/SystemGroup.vala"
		_tmp0_ = "";
#line 1043 "SystemGroup.c"
	}
#line 197 "Utility/SystemGroup.vala"
	_tmp1_ = g_strdup_printf ("groupadd%s %s", _tmp0_, group_name);
#line 197 "Utility/SystemGroup.vala"
	cmd = _tmp1_;
#line 198 "Utility/SystemGroup.vala"
	_tmp2_ = cmd;
#line 198 "Utility/SystemGroup.vala"
	_tmp5_ = tee_jee_process_helper_exec_sync (_tmp2_, &_tmp3_, &_tmp4_);
#line 198 "Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 198 "Utility/SystemGroup.vala"
	std_out = _tmp3_;
#line 198 "Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 198 "Utility/SystemGroup.vala"
	std_err = _tmp4_;
#line 198 "Utility/SystemGroup.vala"
	status = _tmp5_;
#line 199 "Utility/SystemGroup.vala"
	if (status != 0) {
#line 1065 "SystemGroup.c"
		const gchar* _tmp6_;
#line 200 "Utility/SystemGroup.vala"
		_tmp6_ = std_err;
#line 200 "Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 1071 "SystemGroup.c"
	} else {
	}
#line 205 "Utility/SystemGroup.vala"
	result = status;
#line 205 "Utility/SystemGroup.vala"
	_g_free0 (cmd);
#line 205 "Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 205 "Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 205 "Utility/SystemGroup.vala"
	return result;
#line 1084 "SystemGroup.c"
}

gint
system_group_add (SystemGroup* self)
{
	const gchar* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint result = 0;
#line 208 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 209 "Utility/SystemGroup.vala"
	_tmp0_ = self->name;
#line 209 "Utility/SystemGroup.vala"
	_tmp1_ = system_group_get_is_system (self);
#line 209 "Utility/SystemGroup.vala"
	_tmp2_ = _tmp1_;
#line 209 "Utility/SystemGroup.vala"
	result = system_group_add_group (_tmp0_, _tmp2_);
#line 209 "Utility/SystemGroup.vala"
	return result;
#line 1106 "SystemGroup.c"
}

gint
system_group_add_user_to_group (const gchar* user_name,
                                const gchar* group_name)
{
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gint status = 0;
	const gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gint _tmp5_;
	gint result = 0;
#line 212 "Utility/SystemGroup.vala"
	g_return_val_if_fail (user_name != NULL, 0);
#line 212 "Utility/SystemGroup.vala"
	g_return_val_if_fail (group_name != NULL, 0);
#line 214 "Utility/SystemGroup.vala"
	_tmp0_ = g_strdup_printf ("adduser %s %s", user_name, group_name);
#line 214 "Utility/SystemGroup.vala"
	cmd = _tmp0_;
#line 215 "Utility/SystemGroup.vala"
	_tmp1_ = cmd;
#line 215 "Utility/SystemGroup.vala"
	tee_jee_logging_log_debug (_tmp1_);
#line 216 "Utility/SystemGroup.vala"
	_tmp2_ = cmd;
#line 216 "Utility/SystemGroup.vala"
	_tmp5_ = tee_jee_process_helper_exec_sync (_tmp2_, &_tmp3_, &_tmp4_);
#line 216 "Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 216 "Utility/SystemGroup.vala"
	std_out = _tmp3_;
#line 216 "Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 216 "Utility/SystemGroup.vala"
	std_err = _tmp4_;
#line 216 "Utility/SystemGroup.vala"
	status = _tmp5_;
#line 217 "Utility/SystemGroup.vala"
	if (status != 0) {
#line 1152 "SystemGroup.c"
		const gchar* _tmp6_;
#line 218 "Utility/SystemGroup.vala"
		_tmp6_ = std_err;
#line 218 "Utility/SystemGroup.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 1158 "SystemGroup.c"
	} else {
	}
#line 223 "Utility/SystemGroup.vala"
	result = status;
#line 223 "Utility/SystemGroup.vala"
	_g_free0 (cmd);
#line 223 "Utility/SystemGroup.vala"
	_g_free0 (std_err);
#line 223 "Utility/SystemGroup.vala"
	_g_free0 (std_out);
#line 223 "Utility/SystemGroup.vala"
	return result;
#line 1171 "SystemGroup.c"
}

gint
system_group_add_to_group (SystemGroup* self,
                           const gchar* user_name)
{
	const gchar* _tmp0_;
	gint result = 0;
#line 226 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 226 "Utility/SystemGroup.vala"
	g_return_val_if_fail (user_name != NULL, 0);
#line 227 "Utility/SystemGroup.vala"
	_tmp0_ = self->name;
#line 227 "Utility/SystemGroup.vala"
	result = system_group_add_user_to_group (user_name, _tmp0_);
#line 227 "Utility/SystemGroup.vala"
	return result;
#line 1190 "SystemGroup.c"
}

gboolean
system_group_update_group_file (SystemGroup* self)
{
	gchar* file_path = NULL;
	gchar* _tmp0_;
	gchar* txt = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* txt_new = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gboolean result = FALSE;
#line 236 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 237 "Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("/etc/group");
#line 237 "Utility/SystemGroup.vala"
	file_path = _tmp0_;
#line 238 "Utility/SystemGroup.vala"
	_tmp1_ = file_path;
#line 238 "Utility/SystemGroup.vala"
	_tmp2_ = tee_jee_file_system_file_read (_tmp1_);
#line 238 "Utility/SystemGroup.vala"
	txt = _tmp2_;
#line 240 "Utility/SystemGroup.vala"
	_tmp3_ = g_strdup ("");
#line 240 "Utility/SystemGroup.vala"
	txt_new = _tmp3_;
#line 241 "Utility/SystemGroup.vala"
	_tmp4_ = txt;
#line 241 "Utility/SystemGroup.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 1234 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 241 "Utility/SystemGroup.vala"
		line_collection = _tmp6_;
#line 241 "Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp5_);
#line 241 "Utility/SystemGroup.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1246 "SystemGroup.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 241 "Utility/SystemGroup.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 241 "Utility/SystemGroup.vala"
			line = _tmp7_;
#line 1253 "SystemGroup.c"
			{
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gboolean _tmp13_;
				gchar** parts = NULL;
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gchar** _tmp16_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gboolean _tmp28_;
#line 242 "Utility/SystemGroup.vala"
				_tmp8_ = line;
#line 242 "Utility/SystemGroup.vala"
				_tmp9_ = string_strip (_tmp8_);
#line 242 "Utility/SystemGroup.vala"
				_tmp10_ = _tmp9_;
#line 242 "Utility/SystemGroup.vala"
				_tmp11_ = strlen (_tmp10_);
#line 242 "Utility/SystemGroup.vala"
				_tmp12_ = _tmp11_;
#line 242 "Utility/SystemGroup.vala"
				_tmp13_ = _tmp12_ == 0;
#line 242 "Utility/SystemGroup.vala"
				_g_free0 (_tmp10_);
#line 242 "Utility/SystemGroup.vala"
				if (_tmp13_) {
#line 243 "Utility/SystemGroup.vala"
					_g_free0 (line);
#line 243 "Utility/SystemGroup.vala"
					continue;
#line 1296 "SystemGroup.c"
				}
#line 246 "Utility/SystemGroup.vala"
				_tmp14_ = line;
#line 246 "Utility/SystemGroup.vala"
				_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, ":", 0);
#line 246 "Utility/SystemGroup.vala"
				parts = _tmp16_;
#line 246 "Utility/SystemGroup.vala"
				parts_length1 = _vala_array_length (_tmp15_);
#line 246 "Utility/SystemGroup.vala"
				_parts_size_ = parts_length1;
#line 248 "Utility/SystemGroup.vala"
				_tmp17_ = parts;
#line 248 "Utility/SystemGroup.vala"
				_tmp17__length1 = parts_length1;
#line 248 "Utility/SystemGroup.vala"
				if (_tmp17__length1 != 4) {
#line 1314 "SystemGroup.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 249 "Utility/SystemGroup.vala"
					_tmp18_ = parts;
#line 249 "Utility/SystemGroup.vala"
					_tmp18__length1 = parts_length1;
#line 249 "Utility/SystemGroup.vala"
					_tmp19_ = g_strdup_printf (": %d", _tmp18__length1);
#line 249 "Utility/SystemGroup.vala"
					_tmp20_ = _tmp19_;
#line 249 "Utility/SystemGroup.vala"
					_tmp21_ = g_strconcat ("'group' file contains a record with non-standard fields", _tmp20_, NULL);
#line 249 "Utility/SystemGroup.vala"
					_tmp22_ = _tmp21_;
#line 249 "Utility/SystemGroup.vala"
					tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 249 "Utility/SystemGroup.vala"
					_g_free0 (_tmp22_);
#line 249 "Utility/SystemGroup.vala"
					_g_free0 (_tmp20_);
#line 250 "Utility/SystemGroup.vala"
					result = FALSE;
#line 250 "Utility/SystemGroup.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 250 "Utility/SystemGroup.vala"
					_g_free0 (line);
#line 250 "Utility/SystemGroup.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 250 "Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 250 "Utility/SystemGroup.vala"
					_g_free0 (txt);
#line 250 "Utility/SystemGroup.vala"
					_g_free0 (file_path);
#line 250 "Utility/SystemGroup.vala"
					return result;
#line 1355 "SystemGroup.c"
				}
#line 253 "Utility/SystemGroup.vala"
				_tmp23_ = parts;
#line 253 "Utility/SystemGroup.vala"
				_tmp23__length1 = parts_length1;
#line 253 "Utility/SystemGroup.vala"
				_tmp24_ = _tmp23_[0];
#line 253 "Utility/SystemGroup.vala"
				_tmp25_ = string_strip (_tmp24_);
#line 253 "Utility/SystemGroup.vala"
				_tmp26_ = _tmp25_;
#line 253 "Utility/SystemGroup.vala"
				_tmp27_ = self->name;
#line 253 "Utility/SystemGroup.vala"
				_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) == 0;
#line 253 "Utility/SystemGroup.vala"
				_g_free0 (_tmp26_);
#line 253 "Utility/SystemGroup.vala"
				if (_tmp28_) {
#line 1375 "SystemGroup.c"
					const gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 254 "Utility/SystemGroup.vala"
					_tmp29_ = txt_new;
#line 254 "Utility/SystemGroup.vala"
					_tmp30_ = system_group_get_group_line (self);
#line 254 "Utility/SystemGroup.vala"
					_tmp31_ = _tmp30_;
#line 254 "Utility/SystemGroup.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 254 "Utility/SystemGroup.vala"
					_tmp33_ = _tmp32_;
#line 254 "Utility/SystemGroup.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 254 "Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 254 "Utility/SystemGroup.vala"
					txt_new = _tmp34_;
#line 254 "Utility/SystemGroup.vala"
					_g_free0 (_tmp33_);
#line 254 "Utility/SystemGroup.vala"
					_g_free0 (_tmp31_);
#line 1402 "SystemGroup.c"
				} else {
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
#line 257 "Utility/SystemGroup.vala"
					_tmp35_ = txt_new;
#line 257 "Utility/SystemGroup.vala"
					_tmp36_ = line;
#line 257 "Utility/SystemGroup.vala"
					_tmp37_ = g_strconcat (_tmp36_, "\n", NULL);
#line 257 "Utility/SystemGroup.vala"
					_tmp38_ = _tmp37_;
#line 257 "Utility/SystemGroup.vala"
					_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 257 "Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 257 "Utility/SystemGroup.vala"
					txt_new = _tmp39_;
#line 257 "Utility/SystemGroup.vala"
					_g_free0 (_tmp38_);
#line 1425 "SystemGroup.c"
				}
#line 241 "Utility/SystemGroup.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 241 "Utility/SystemGroup.vala"
				_g_free0 (line);
#line 1431 "SystemGroup.c"
			}
		}
#line 241 "Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1436 "SystemGroup.c"
	}
#line 261 "Utility/SystemGroup.vala"
	_tmp40_ = file_path;
#line 261 "Utility/SystemGroup.vala"
	_tmp41_ = txt_new;
#line 261 "Utility/SystemGroup.vala"
	tee_jee_file_system_file_write (_tmp40_, _tmp41_);
#line 263 "Utility/SystemGroup.vala"
	_tmp42_ = self->name;
#line 263 "Utility/SystemGroup.vala"
	_tmp43_ = g_strdup_printf (": %s", _tmp42_);
#line 263 "Utility/SystemGroup.vala"
	_tmp44_ = _tmp43_;
#line 263 "Utility/SystemGroup.vala"
	_tmp45_ = g_strconcat ("Updated group settings in /etc/group", _tmp44_, NULL);
#line 263 "Utility/SystemGroup.vala"
	_tmp46_ = _tmp45_;
#line 263 "Utility/SystemGroup.vala"
	tee_jee_logging_log_msg (_tmp46_, FALSE);
#line 263 "Utility/SystemGroup.vala"
	_g_free0 (_tmp46_);
#line 263 "Utility/SystemGroup.vala"
	_g_free0 (_tmp44_);
#line 265 "Utility/SystemGroup.vala"
	result = TRUE;
#line 265 "Utility/SystemGroup.vala"
	_g_free0 (txt_new);
#line 265 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 265 "Utility/SystemGroup.vala"
	_g_free0 (file_path);
#line 265 "Utility/SystemGroup.vala"
	return result;
#line 1470 "SystemGroup.c"
}

gchar*
system_group_get_group_line (SystemGroup* self)
{
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* result = NULL;
#line 268 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 269 "Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("");
#line 269 "Utility/SystemGroup.vala"
	txt = _tmp0_;
#line 270 "Utility/SystemGroup.vala"
	_tmp1_ = txt;
#line 270 "Utility/SystemGroup.vala"
	_tmp2_ = self->name;
#line 270 "Utility/SystemGroup.vala"
	_tmp3_ = g_strdup_printf ("%s", _tmp2_);
#line 270 "Utility/SystemGroup.vala"
	_tmp4_ = _tmp3_;
#line 270 "Utility/SystemGroup.vala"
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 270 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 270 "Utility/SystemGroup.vala"
	txt = _tmp5_;
#line 270 "Utility/SystemGroup.vala"
	_g_free0 (_tmp4_);
#line 271 "Utility/SystemGroup.vala"
	_tmp6_ = txt;
#line 271 "Utility/SystemGroup.vala"
	_tmp7_ = self->password;
#line 271 "Utility/SystemGroup.vala"
	_tmp8_ = g_strdup_printf (":%s", _tmp7_);
#line 271 "Utility/SystemGroup.vala"
	_tmp9_ = _tmp8_;
#line 271 "Utility/SystemGroup.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 271 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 271 "Utility/SystemGroup.vala"
	txt = _tmp10_;
#line 271 "Utility/SystemGroup.vala"
	_g_free0 (_tmp9_);
#line 272 "Utility/SystemGroup.vala"
	_tmp11_ = txt;
#line 272 "Utility/SystemGroup.vala"
	_tmp12_ = g_strdup_printf (":%d", self->gid);
#line 272 "Utility/SystemGroup.vala"
	_tmp13_ = _tmp12_;
#line 272 "Utility/SystemGroup.vala"
	_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
#line 272 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 272 "Utility/SystemGroup.vala"
	txt = _tmp14_;
#line 272 "Utility/SystemGroup.vala"
	_g_free0 (_tmp13_);
#line 273 "Utility/SystemGroup.vala"
	_tmp15_ = txt;
#line 273 "Utility/SystemGroup.vala"
	_tmp16_ = self->user_names;
#line 273 "Utility/SystemGroup.vala"
	_tmp17_ = g_strdup_printf (":%s", _tmp16_);
#line 273 "Utility/SystemGroup.vala"
	_tmp18_ = _tmp17_;
#line 273 "Utility/SystemGroup.vala"
	_tmp19_ = g_strconcat (_tmp15_, _tmp18_, NULL);
#line 273 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 273 "Utility/SystemGroup.vala"
	txt = _tmp19_;
#line 273 "Utility/SystemGroup.vala"
	_g_free0 (_tmp18_);
#line 274 "Utility/SystemGroup.vala"
	result = txt;
#line 274 "Utility/SystemGroup.vala"
	return result;
#line 1570 "SystemGroup.c"
}

gboolean
system_group_update_gshadow_file (SystemGroup* self)
{
	gchar* file_path = NULL;
	gchar* _tmp0_;
	gchar* txt = NULL;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* txt_new = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	const gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gboolean result = FALSE;
#line 277 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 278 "Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("/etc/gshadow");
#line 278 "Utility/SystemGroup.vala"
	file_path = _tmp0_;
#line 279 "Utility/SystemGroup.vala"
	_tmp1_ = file_path;
#line 279 "Utility/SystemGroup.vala"
	_tmp2_ = tee_jee_file_system_file_read (_tmp1_);
#line 279 "Utility/SystemGroup.vala"
	txt = _tmp2_;
#line 281 "Utility/SystemGroup.vala"
	_tmp3_ = g_strdup ("");
#line 281 "Utility/SystemGroup.vala"
	txt_new = _tmp3_;
#line 282 "Utility/SystemGroup.vala"
	_tmp4_ = txt;
#line 282 "Utility/SystemGroup.vala"
	_tmp6_ = _tmp5_ = g_strsplit (_tmp4_, "\n", 0);
#line 1614 "SystemGroup.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 282 "Utility/SystemGroup.vala"
		line_collection = _tmp6_;
#line 282 "Utility/SystemGroup.vala"
		line_collection_length1 = _vala_array_length (_tmp5_);
#line 282 "Utility/SystemGroup.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1626 "SystemGroup.c"
			gchar* _tmp7_;
			gchar* line = NULL;
#line 282 "Utility/SystemGroup.vala"
			_tmp7_ = g_strdup (line_collection[line_it]);
#line 282 "Utility/SystemGroup.vala"
			line = _tmp7_;
#line 1633 "SystemGroup.c"
			{
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				gboolean _tmp13_;
				gchar** parts = NULL;
				const gchar* _tmp14_;
				gchar** _tmp15_;
				gchar** _tmp16_;
				gint parts_length1;
				gint _parts_size_;
				gchar** _tmp17_;
				gint _tmp17__length1;
				gchar** _tmp23_;
				gint _tmp23__length1;
				const gchar* _tmp24_;
				gchar* _tmp25_;
				gchar* _tmp26_;
				const gchar* _tmp27_;
				gboolean _tmp28_;
#line 283 "Utility/SystemGroup.vala"
				_tmp8_ = line;
#line 283 "Utility/SystemGroup.vala"
				_tmp9_ = string_strip (_tmp8_);
#line 283 "Utility/SystemGroup.vala"
				_tmp10_ = _tmp9_;
#line 283 "Utility/SystemGroup.vala"
				_tmp11_ = strlen (_tmp10_);
#line 283 "Utility/SystemGroup.vala"
				_tmp12_ = _tmp11_;
#line 283 "Utility/SystemGroup.vala"
				_tmp13_ = _tmp12_ == 0;
#line 283 "Utility/SystemGroup.vala"
				_g_free0 (_tmp10_);
#line 283 "Utility/SystemGroup.vala"
				if (_tmp13_) {
#line 284 "Utility/SystemGroup.vala"
					_g_free0 (line);
#line 284 "Utility/SystemGroup.vala"
					continue;
#line 1676 "SystemGroup.c"
				}
#line 287 "Utility/SystemGroup.vala"
				_tmp14_ = line;
#line 287 "Utility/SystemGroup.vala"
				_tmp16_ = _tmp15_ = g_strsplit (_tmp14_, ":", 0);
#line 287 "Utility/SystemGroup.vala"
				parts = _tmp16_;
#line 287 "Utility/SystemGroup.vala"
				parts_length1 = _vala_array_length (_tmp15_);
#line 287 "Utility/SystemGroup.vala"
				_parts_size_ = parts_length1;
#line 289 "Utility/SystemGroup.vala"
				_tmp17_ = parts;
#line 289 "Utility/SystemGroup.vala"
				_tmp17__length1 = parts_length1;
#line 289 "Utility/SystemGroup.vala"
				if (_tmp17__length1 != 4) {
#line 1694 "SystemGroup.c"
					gchar** _tmp18_;
					gint _tmp18__length1;
					gchar* _tmp19_;
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
#line 290 "Utility/SystemGroup.vala"
					_tmp18_ = parts;
#line 290 "Utility/SystemGroup.vala"
					_tmp18__length1 = parts_length1;
#line 290 "Utility/SystemGroup.vala"
					_tmp19_ = g_strdup_printf (": %d", _tmp18__length1);
#line 290 "Utility/SystemGroup.vala"
					_tmp20_ = _tmp19_;
#line 290 "Utility/SystemGroup.vala"
					_tmp21_ = g_strconcat ("'gshadow' file contains a record with non-standard fields", _tmp20_, NULL);
#line 290 "Utility/SystemGroup.vala"
					_tmp22_ = _tmp21_;
#line 290 "Utility/SystemGroup.vala"
					tee_jee_logging_log_error (_tmp22_, FALSE, FALSE);
#line 290 "Utility/SystemGroup.vala"
					_g_free0 (_tmp22_);
#line 290 "Utility/SystemGroup.vala"
					_g_free0 (_tmp20_);
#line 291 "Utility/SystemGroup.vala"
					result = FALSE;
#line 291 "Utility/SystemGroup.vala"
					parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 291 "Utility/SystemGroup.vala"
					_g_free0 (line);
#line 291 "Utility/SystemGroup.vala"
					line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 291 "Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 291 "Utility/SystemGroup.vala"
					_g_free0 (txt);
#line 291 "Utility/SystemGroup.vala"
					_g_free0 (file_path);
#line 291 "Utility/SystemGroup.vala"
					return result;
#line 1735 "SystemGroup.c"
				}
#line 294 "Utility/SystemGroup.vala"
				_tmp23_ = parts;
#line 294 "Utility/SystemGroup.vala"
				_tmp23__length1 = parts_length1;
#line 294 "Utility/SystemGroup.vala"
				_tmp24_ = _tmp23_[0];
#line 294 "Utility/SystemGroup.vala"
				_tmp25_ = string_strip (_tmp24_);
#line 294 "Utility/SystemGroup.vala"
				_tmp26_ = _tmp25_;
#line 294 "Utility/SystemGroup.vala"
				_tmp27_ = self->name;
#line 294 "Utility/SystemGroup.vala"
				_tmp28_ = g_strcmp0 (_tmp26_, _tmp27_) == 0;
#line 294 "Utility/SystemGroup.vala"
				_g_free0 (_tmp26_);
#line 294 "Utility/SystemGroup.vala"
				if (_tmp28_) {
#line 1755 "SystemGroup.c"
					const gchar* _tmp29_;
					gchar* _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
					gchar* _tmp34_;
#line 295 "Utility/SystemGroup.vala"
					_tmp29_ = txt_new;
#line 295 "Utility/SystemGroup.vala"
					_tmp30_ = system_group_get_gshadow_line (self);
#line 295 "Utility/SystemGroup.vala"
					_tmp31_ = _tmp30_;
#line 295 "Utility/SystemGroup.vala"
					_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
#line 295 "Utility/SystemGroup.vala"
					_tmp33_ = _tmp32_;
#line 295 "Utility/SystemGroup.vala"
					_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
#line 295 "Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 295 "Utility/SystemGroup.vala"
					txt_new = _tmp34_;
#line 295 "Utility/SystemGroup.vala"
					_g_free0 (_tmp33_);
#line 295 "Utility/SystemGroup.vala"
					_g_free0 (_tmp31_);
#line 1782 "SystemGroup.c"
				} else {
					const gchar* _tmp35_;
					const gchar* _tmp36_;
					gchar* _tmp37_;
					gchar* _tmp38_;
					gchar* _tmp39_;
#line 298 "Utility/SystemGroup.vala"
					_tmp35_ = txt_new;
#line 298 "Utility/SystemGroup.vala"
					_tmp36_ = line;
#line 298 "Utility/SystemGroup.vala"
					_tmp37_ = g_strconcat (_tmp36_, "\n", NULL);
#line 298 "Utility/SystemGroup.vala"
					_tmp38_ = _tmp37_;
#line 298 "Utility/SystemGroup.vala"
					_tmp39_ = g_strconcat (_tmp35_, _tmp38_, NULL);
#line 298 "Utility/SystemGroup.vala"
					_g_free0 (txt_new);
#line 298 "Utility/SystemGroup.vala"
					txt_new = _tmp39_;
#line 298 "Utility/SystemGroup.vala"
					_g_free0 (_tmp38_);
#line 1805 "SystemGroup.c"
				}
#line 282 "Utility/SystemGroup.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 282 "Utility/SystemGroup.vala"
				_g_free0 (line);
#line 1811 "SystemGroup.c"
			}
		}
#line 282 "Utility/SystemGroup.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1816 "SystemGroup.c"
	}
#line 302 "Utility/SystemGroup.vala"
	_tmp40_ = file_path;
#line 302 "Utility/SystemGroup.vala"
	_tmp41_ = txt_new;
#line 302 "Utility/SystemGroup.vala"
	tee_jee_file_system_file_write (_tmp40_, _tmp41_);
#line 304 "Utility/SystemGroup.vala"
	_tmp42_ = self->name;
#line 304 "Utility/SystemGroup.vala"
	_tmp43_ = g_strdup_printf (": %s", _tmp42_);
#line 304 "Utility/SystemGroup.vala"
	_tmp44_ = _tmp43_;
#line 304 "Utility/SystemGroup.vala"
	_tmp45_ = g_strconcat ("Updated group settings in /etc/gshadow", _tmp44_, NULL);
#line 304 "Utility/SystemGroup.vala"
	_tmp46_ = _tmp45_;
#line 304 "Utility/SystemGroup.vala"
	tee_jee_logging_log_msg (_tmp46_, FALSE);
#line 304 "Utility/SystemGroup.vala"
	_g_free0 (_tmp46_);
#line 304 "Utility/SystemGroup.vala"
	_g_free0 (_tmp44_);
#line 306 "Utility/SystemGroup.vala"
	result = TRUE;
#line 306 "Utility/SystemGroup.vala"
	_g_free0 (txt_new);
#line 306 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 306 "Utility/SystemGroup.vala"
	_g_free0 (file_path);
#line 306 "Utility/SystemGroup.vala"
	return result;
#line 1850 "SystemGroup.c"
}

gchar*
system_group_get_gshadow_line (SystemGroup* self)
{
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* result = NULL;
#line 309 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 310 "Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("");
#line 310 "Utility/SystemGroup.vala"
	txt = _tmp0_;
#line 311 "Utility/SystemGroup.vala"
	_tmp1_ = txt;
#line 311 "Utility/SystemGroup.vala"
	_tmp2_ = self->name;
#line 311 "Utility/SystemGroup.vala"
	_tmp3_ = g_strdup_printf ("%s", _tmp2_);
#line 311 "Utility/SystemGroup.vala"
	_tmp4_ = _tmp3_;
#line 311 "Utility/SystemGroup.vala"
	_tmp5_ = g_strconcat (_tmp1_, _tmp4_, NULL);
#line 311 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 311 "Utility/SystemGroup.vala"
	txt = _tmp5_;
#line 311 "Utility/SystemGroup.vala"
	_g_free0 (_tmp4_);
#line 312 "Utility/SystemGroup.vala"
	_tmp6_ = txt;
#line 312 "Utility/SystemGroup.vala"
	_tmp7_ = self->password_hash;
#line 312 "Utility/SystemGroup.vala"
	_tmp8_ = g_strdup_printf (":%s", _tmp7_);
#line 312 "Utility/SystemGroup.vala"
	_tmp9_ = _tmp8_;
#line 312 "Utility/SystemGroup.vala"
	_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 312 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 312 "Utility/SystemGroup.vala"
	txt = _tmp10_;
#line 312 "Utility/SystemGroup.vala"
	_g_free0 (_tmp9_);
#line 313 "Utility/SystemGroup.vala"
	_tmp11_ = txt;
#line 313 "Utility/SystemGroup.vala"
	_tmp12_ = self->admin_list;
#line 313 "Utility/SystemGroup.vala"
	_tmp13_ = g_strdup_printf (":%s", _tmp12_);
#line 313 "Utility/SystemGroup.vala"
	_tmp14_ = _tmp13_;
#line 313 "Utility/SystemGroup.vala"
	_tmp15_ = g_strconcat (_tmp11_, _tmp14_, NULL);
#line 313 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 313 "Utility/SystemGroup.vala"
	txt = _tmp15_;
#line 313 "Utility/SystemGroup.vala"
	_g_free0 (_tmp14_);
#line 314 "Utility/SystemGroup.vala"
	_tmp16_ = txt;
#line 314 "Utility/SystemGroup.vala"
	_tmp17_ = self->member_list;
#line 314 "Utility/SystemGroup.vala"
	_tmp18_ = g_strdup_printf (":%s", _tmp17_);
#line 314 "Utility/SystemGroup.vala"
	_tmp19_ = _tmp18_;
#line 314 "Utility/SystemGroup.vala"
	_tmp20_ = g_strconcat (_tmp16_, _tmp19_, NULL);
#line 314 "Utility/SystemGroup.vala"
	_g_free0 (txt);
#line 314 "Utility/SystemGroup.vala"
	txt = _tmp20_;
#line 314 "Utility/SystemGroup.vala"
	_g_free0 (_tmp19_);
#line 315 "Utility/SystemGroup.vala"
	result = txt;
#line 315 "Utility/SystemGroup.vala"
	return result;
#line 1953 "SystemGroup.c"
}

static gint
_system_group_all_groups_sorted___lambda17_ (SystemGroup* a,
                                             SystemGroup* b)
{
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result = 0;
#line 66 "Utility/SystemGroup.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 66 "Utility/SystemGroup.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 66 "Utility/SystemGroup.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 66 "Utility/SystemGroup.vala"
	_tmp1_ = a->name;
#line 66 "Utility/SystemGroup.vala"
	_tmp2_ = b->name;
#line 66 "Utility/SystemGroup.vala"
	result = _tmp0_ (_tmp1_, _tmp2_);
#line 66 "Utility/SystemGroup.vala"
	return result;
#line 1978 "SystemGroup.c"
}

static gint
__system_group_all_groups_sorted___lambda17__gcompare_data_func (gconstpointer a,
                                                                 gconstpointer b,
                                                                 gpointer self)
{
	gint result;
	result = _system_group_all_groups_sorted___lambda17_ ((SystemGroup*) a, (SystemGroup*) b);
#line 66 "Utility/SystemGroup.vala"
	return result;
#line 1990 "SystemGroup.c"
}

GeeArrayList*
system_group_get_all_groups_sorted (void)
{
	GeeArrayList* result;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp12_;
#line 62 "Utility/SystemGroup.vala"
	_tmp0_ = gee_array_list_new (TYPE_SYSTEM_GROUP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 62 "Utility/SystemGroup.vala"
	list = _tmp0_;
#line 2004 "SystemGroup.c"
	{
		GeeIterator* _group_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 63 "Utility/SystemGroup.vala"
		_tmp1_ = system_group_all_groups;
#line 63 "Utility/SystemGroup.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 63 "Utility/SystemGroup.vala"
		_tmp3_ = _tmp2_;
#line 63 "Utility/SystemGroup.vala"
		_tmp4_ = _tmp3_;
#line 63 "Utility/SystemGroup.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 63 "Utility/SystemGroup.vala"
		_tmp6_ = _tmp5_;
#line 63 "Utility/SystemGroup.vala"
		_g_object_unref0 (_tmp4_);
#line 63 "Utility/SystemGroup.vala"
		_group_it = _tmp6_;
#line 63 "Utility/SystemGroup.vala"
		while (TRUE) {
#line 2031 "SystemGroup.c"
			GeeIterator* _tmp7_;
			SystemGroup* group = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeArrayList* _tmp10_;
			SystemGroup* _tmp11_;
#line 63 "Utility/SystemGroup.vala"
			_tmp7_ = _group_it;
#line 63 "Utility/SystemGroup.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 63 "Utility/SystemGroup.vala"
				break;
#line 2044 "SystemGroup.c"
			}
#line 63 "Utility/SystemGroup.vala"
			_tmp8_ = _group_it;
#line 63 "Utility/SystemGroup.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 63 "Utility/SystemGroup.vala"
			group = (SystemGroup*) _tmp9_;
#line 64 "Utility/SystemGroup.vala"
			_tmp10_ = list;
#line 64 "Utility/SystemGroup.vala"
			_tmp11_ = group;
#line 64 "Utility/SystemGroup.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 63 "Utility/SystemGroup.vala"
			_g_object_unref0 (group);
#line 2060 "SystemGroup.c"
		}
#line 63 "Utility/SystemGroup.vala"
		_g_object_unref0 (_group_it);
#line 2064 "SystemGroup.c"
	}
#line 66 "Utility/SystemGroup.vala"
	_tmp12_ = list;
#line 66 "Utility/SystemGroup.vala"
	gee_list_sort ((GeeList*) _tmp12_, __system_group_all_groups_sorted___lambda17__gcompare_data_func, NULL, NULL);
#line 67 "Utility/SystemGroup.vala"
	result = list;
#line 67 "Utility/SystemGroup.vala"
	return result;
#line 2074 "SystemGroup.c"
}

gboolean
system_group_get_is_installed (SystemGroup* self)
{
	gboolean result;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
#line 72 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "Utility/SystemGroup.vala"
	_tmp0_ = system_group_all_groups;
#line 73 "Utility/SystemGroup.vala"
	_tmp1_ = self->name;
#line 73 "Utility/SystemGroup.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 73 "Utility/SystemGroup.vala"
	return result;
#line 2093 "SystemGroup.c"
}

gboolean
system_group_get_is_system (SystemGroup* self)
{
	gboolean result;
#line 231 "Utility/SystemGroup.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 232 "Utility/SystemGroup.vala"
	result = self->gid < 1000;
#line 232 "Utility/SystemGroup.vala"
	return result;
#line 2106 "SystemGroup.c"
}

static void
system_group_class_init (SystemGroupClass * klass,
                         gpointer klass_data)
{
#line 29 "Utility/SystemGroup.vala"
	system_group_parent_class = g_type_class_peek_parent (klass);
#line 29 "Utility/SystemGroup.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_system_group_get_property;
#line 29 "Utility/SystemGroup.vala"
	G_OBJECT_CLASS (klass)->finalize = system_group_finalize;
#line 29 "Utility/SystemGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_GROUP_IS_INSTALLED_PROPERTY, system_group_properties[SYSTEM_GROUP_IS_INSTALLED_PROPERTY] = g_param_spec_boolean ("is-installed", "is-installed", "is-installed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "Utility/SystemGroup.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_GROUP_IS_SYSTEM_PROPERTY, system_group_properties[SYSTEM_GROUP_IS_SYSTEM_PROPERTY] = g_param_spec_boolean ("is-system", "is-system", "is-system", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2123 "SystemGroup.c"
}

static void
system_group_instance_init (SystemGroup * self,
                            gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 31 "Utility/SystemGroup.vala"
	_tmp0_ = g_strdup ("");
#line 31 "Utility/SystemGroup.vala"
	self->name = _tmp0_;
#line 32 "Utility/SystemGroup.vala"
	_tmp1_ = g_strdup ("");
#line 32 "Utility/SystemGroup.vala"
	self->password = _tmp1_;
#line 33 "Utility/SystemGroup.vala"
	self->gid = -1;
#line 34 "Utility/SystemGroup.vala"
	_tmp2_ = g_strdup ("");
#line 34 "Utility/SystemGroup.vala"
	self->user_names = _tmp2_;
#line 36 "Utility/SystemGroup.vala"
	_tmp3_ = g_strdup ("");
#line 36 "Utility/SystemGroup.vala"
	self->shadow_line = _tmp3_;
#line 37 "Utility/SystemGroup.vala"
	_tmp4_ = g_strdup ("");
#line 37 "Utility/SystemGroup.vala"
	self->password_hash = _tmp4_;
#line 38 "Utility/SystemGroup.vala"
	_tmp5_ = g_strdup ("");
#line 38 "Utility/SystemGroup.vala"
	self->admin_list = _tmp5_;
#line 39 "Utility/SystemGroup.vala"
	_tmp6_ = g_strdup ("");
#line 39 "Utility/SystemGroup.vala"
	self->member_list = _tmp6_;
#line 41 "Utility/SystemGroup.vala"
	self->is_selected = FALSE;
#line 2169 "SystemGroup.c"
}

static void
system_group_finalize (GObject * obj)
{
	SystemGroup * self;
#line 29 "Utility/SystemGroup.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SYSTEM_GROUP, SystemGroup);
#line 31 "Utility/SystemGroup.vala"
	_g_free0 (self->name);
#line 32 "Utility/SystemGroup.vala"
	_g_free0 (self->password);
#line 34 "Utility/SystemGroup.vala"
	_g_free0 (self->user_names);
#line 36 "Utility/SystemGroup.vala"
	_g_free0 (self->shadow_line);
#line 37 "Utility/SystemGroup.vala"
	_g_free0 (self->password_hash);
#line 38 "Utility/SystemGroup.vala"
	_g_free0 (self->admin_list);
#line 39 "Utility/SystemGroup.vala"
	_g_free0 (self->member_list);
#line 42 "Utility/SystemGroup.vala"
	_g_object_unref0 (self->users);
#line 29 "Utility/SystemGroup.vala"
	G_OBJECT_CLASS (system_group_parent_class)->finalize (obj);
#line 2196 "SystemGroup.c"
}

static GType
system_group_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SystemGroupClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) system_group_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SystemGroup), 0, (GInstanceInitFunc) system_group_instance_init, NULL };
	GType system_group_type_id;
	system_group_type_id = g_type_register_static (G_TYPE_OBJECT, "SystemGroup", &g_define_type_info, 0);
	return system_group_type_id;
}

GType
system_group_get_type (void)
{
	static volatile gsize system_group_type_id__volatile = 0;
	if (g_once_init_enter (&system_group_type_id__volatile)) {
		GType system_group_type_id;
		system_group_type_id = system_group_get_type_once ();
		g_once_init_leave (&system_group_type_id__volatile, system_group_type_id);
	}
	return system_group_type_id__volatile;
}

static void
_vala_system_group_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SystemGroup * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SYSTEM_GROUP, SystemGroup);
#line 29 "Utility/SystemGroup.vala"
	switch (property_id) {
#line 29 "Utility/SystemGroup.vala"
		case SYSTEM_GROUP_IS_INSTALLED_PROPERTY:
#line 29 "Utility/SystemGroup.vala"
		g_value_set_boolean (value, system_group_get_is_installed (self));
#line 29 "Utility/SystemGroup.vala"
		break;
#line 29 "Utility/SystemGroup.vala"
		case SYSTEM_GROUP_IS_SYSTEM_PROPERTY:
#line 29 "Utility/SystemGroup.vala"
		g_value_set_boolean (value, system_group_get_is_system (self));
#line 29 "Utility/SystemGroup.vala"
		break;
#line 2242 "SystemGroup.c"
		default:
#line 29 "Utility/SystemGroup.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "Utility/SystemGroup.vala"
		break;
#line 2248 "SystemGroup.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

